import { LRLanguage, LanguageSupport } from '@codemirror/language';
import { Extension } from '@codemirror/state';

declare const surrealqlLanguage: LRLanguage;
type Scope = "permission" | "index" | "combined-results" | "syntax";
/**
 * A linter that checks if the syntax tree uses features that are not available in the given SurrealDB version
 *
 * @param version The SurrealDB version to check against (e.g. "2.0.0")
 */
declare function surrealqlVersionLinter(version: string): Extension;
/**
 * The CodeMirror extension used to add support for the SurrealQL language
 *
 * @param scope Limit the scope of the highlighting
 */
declare function surrealql(scope?: Scope): LanguageSupport;

export { surrealql, surrealqlLanguage, surrealqlVersionLinter };
